import { PromiseProgress } from './promise-progress';
export type DecodedResponse<T> = Response & {
    data?: T;
};
export type HttpInterceptor = (response: Response, next: () => void) => void;
export type HttpRequestOptions = {
    url?: string;
    fragment?: string;
    query?: {
        key: string;
        value: string;
    }[] | {
        [key: string]: string;
    };
    method?: 'GET' | 'POST' | 'PATCH' | 'DELETE';
    body?: any;
    headers?: {
        [key: string | symbol]: string | null | undefined;
    };
    [key: string]: any;
};
export type HttpDefaults = {
    headers?: {
        [key: string | symbol]: string | null | undefined;
    };
    interceptors?: HttpInterceptor[];
    url?: string;
};
export declare class Http {
    private static interceptors;
    static headers: {
        [key: string]: string | null | undefined;
    };
    private interceptors;
    headers: {
        [key: string]: string | null | undefined;
    };
    url: string | null;
    constructor(defaults?: HttpDefaults);
    static addInterceptor(fn: HttpInterceptor): () => void;
    addInterceptor(fn: HttpInterceptor): () => void;
    request<T>(opts?: HttpRequestOptions): PromiseProgress<DecodedResponse<T>>;
}
