export type ProgressCallback = (progress: number) => any;
export declare class PromiseProgress<T> extends Promise<T> {
    private listeners;
    private _progress;
    get progress(): number;
    set progress(p: number);
    constructor(executor: (resolve: (value: T) => any, reject: (reason: any) => void, progress: (progress: number) => any) => void);
    static from<T>(promise: Promise<T>): PromiseProgress<T>;
    private from;
    onProgress(callback: ProgressCallback): this;
    then(res?: (v: T) => any, rej?: (err: any) => any): PromiseProgress<any>;
    catch(rej?: (err: any) => any): PromiseProgress<any>;
    finally(res?: () => any): PromiseProgress<any>;
}
